<template>
    <div id="page-wrapper">
        <nav-bar></nav-bar>
        <div id="auth-container">
            <form class="form-change-password" @submit.prevent="handleSubmit()" autocomplete="off">
                <img class="mb-4" src="https://static.thenounproject.com/png/2068751-200.png" alt="" width="72"
                     height="72">
                <div class="mt-3 text-left">
                    <label for="inputOldPassword">Current Password</label>
                    <input type="password" id="inputOldPassword" class="form-control" placeholder="Current Password"
                           required=""
                           autofocus="" v-model="changePasswordForm.currentPassword">
                </div>
                <div class="mt-3 text-left">
                    <label for="inputNewPassword">Old Password</label>
                    <input type="password" id="inputNewPassword" class="form-control" placeholder="New Password"
                           required=""
                           v-model="changePasswordForm.newPassword">
                </div>
                <div class="mt-3">
                    <button class="btn btn-lg btn-login btn-block" type="submit">CONFIRM</button>
                </div>
            </form>
            <div v-if="result" class="mt-4">
                <span>{{result}}</span>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
    import {Component, Vue} from "vue-property-decorator";
    import {AxiosResponse} from "axios";
    import NavBar from "@/components/NavBar.vue";
    import {AuthUtils} from "@/utils/auth-utils";

    const INIT_STATE = {currentPassword: "", newPassword: ""};

    @Component({
        components: {NavBar}
    })
    export default class ChangePassword extends Vue {
        public changePasswordForm = {...INIT_STATE};

        public result: string = "";

        public handleSubmit(): void {
            const {currentPassword, newPassword} = this.changePasswordForm;
            if (!!currentPassword && !!newPassword) {
                const data = `currentPassword=${encodeURIComponent(currentPassword)}&newPassword=${encodeURIComponent(newPassword)}`;
                this.$http
                    .post("http://localhost:8080/api/users/change-password", data, AuthUtils.authorizedHeader())
                    .then((response: AxiosResponse) => {
                        this.result = "😁 The password has been updated.";
                    })
                    .catch(error => {
                        this.result = `😖 ${error.response.data.message}`;
                    });
            } else {
                this.result = "☝️ Provide current password and new password.";
            }
        }
    }
</script>

<style scoped lang="scss">
    #page-wrapper {
        height: 100vh;
        overflow: hidden;
        background-color: #db4c4633;

        #auth-container {
            max-width: 30em;
            margin: 13% auto;
            background-color: snow;
            border-radius: 1em;
            border: 1px solid #db4c46;
            padding: 3em;
            color: #ff1c16;

            .form-change-password {
                width: 100%;

                .btn-login {
                    color: #fff;
                    background-color: #d9534f;
                    border: 2px solid #d43f3a;
                    border-radius: 0 !important;
                    font-variant: all-small-caps;

                    &:hover {
                        background-color: snow;
                        color: #ff1c16;
                        border: 2px solid #ff1c16;
                    }
                }
            }
        }
    }
</style>
